SystemOrganization addCategory: #'Pier-TagCloud'!

!MADescription methodsFor: '*pier-tagcloud' stamp: 'lr 9/13/2007 10:22'!
beTagCloud
	self propertyAt: #tagCloud put: true! !

!MADescription methodsFor: '*pier-tagcloud' stamp: 'lr 9/13/2007 10:22'!
isTagCloud
	^ self propertyAt: #tagCloud ifAbsent: [ false ]! !

!GRPackage class methodsFor: '*pier-tagcloud' stamp: 'lr 2/26/2010 23:09'!
pierTagCloud
	^ self new
		name: 'Pier-TagCloud';
		description: 'A tag cloud for Pier.';
		addDependency: 'Pier-Model';
		addDependency: 'Pier-Seaside';
		url: #pierAddonsUrl;
		yourself! !

!PRCase methodsFor: '*pier-tagcloud-descriptions' stamp: 'NickAger 1/30/2012 18:09'!
descriptionDocumentTagCloud: aDescription
	<magritteDescription: #descriptionDocument>
	^ aDescription beTagCloud! !

!PRCase methodsFor: '*pier-tagcloud-descriptions' stamp: 'NickAger 1/30/2012 18:09'!
descriptionPlainTextTagCloud: aDescription
	<magritteDescription: #descriptionPlainText>
	^ aDescription beTagCloud! !

!PRStructure methodsFor: '*pier-tagcloud-descriptions' stamp: 'NickAger 1/30/2012 18:10'!
descriptionMenuTagCloud: aDescription
	^ aDescription beTagCloud! !

!PRStructure methodsFor: '*pier-tagcloud-descriptions' stamp: 'NickAger 1/30/2012 18:10'!
descriptionNameTagCloud: aDescription
	<magritteDescription: #descriptionName>
	^ aDescription beTagCloud! !

!PRStructure methodsFor: '*pier-tagcloud-descriptions' stamp: 'NickAger 1/30/2012 18:10'!
descriptionTagsTagCloud: aDescription
	<magritteDescription: #descriptionTags>
	^ aDescription beTagCloud! !

!PRStructure methodsFor: '*pier-tagcloud-descriptions' stamp: 'NickAger 1/30/2012 18:10'!
descriptionTitleTagCloud: aDescription
	<magritteDescription: #descriptionTitle>
	^ aDescription beTagCloud! !

!PRStructure methodsFor: '*pier-tagcloud' stamp: 'lr 9/13/2007 10:09'!
tagsUsing: aCollection
	"Answer a list of tags using the given aCollection of descriptions."
	
	^ aCollection
		inject: OrderedCollection new
		into: [ :collection :each |
			collection addAll: ((each toString: (self readUsing: each))
				findTokens: ' ').
			collection ]! !

PRWidget subclass: #PRTagCloudWidget
	instanceVariableNames: 'tags tagsByCount tagsByName focus mean deviation ignoredTags maxItems showExponential showFrequencies startAt dataDescriptions'
	classVariableNames: 'StopWords'
	poolDictionaries: ''
	category: 'Pier-TagCloud'!

!PRTagCloudWidget class methodsFor: 'initialization' stamp: 'NickAger 10/24/2010 22:41'!
initialize
	StopWords := Set withAll: #('--' '---' 'about' 'all' 'an' 'and' 'are' 'as' 'at' 'be' 'being' 'but' 'by' 'can' 'com' 'de' 'do' 'en' 'first' 'for' 'from' 'go' 'has' 'have' 'he' 'her' 'here' 'hers' 'herself' 'him' 'himself' 'how' 'if' 'in' 'is' 'it' 'its' 'itself' 'la' 'just' 'me' 'mine' 'more' 'my' 'myself' 'not' 'of' 'on' 'oneself' 'or' 'our' 'ours' 'ourselves' 'out' 'really' 'she' 'so' 'some' 'such' 'that' 'the' 'their' 'theirs' 'them' 'themselves' 'there' 'these' 'they' 'this' 'those' 'to' 'und' 'us' 'use' 'using' 'very' 'was' 'we' 'what' 'when' 'where' 'who' 'will' 'with' 'www' 'you' 'your' 'yours' 'yourself' 'yourselves')! !

!PRTagCloudWidget class methodsFor: 'testing' stamp: 'lr 9/12/2007 22:55'!
isAbstract
	^ false! !

!PRTagCloudWidget class methodsFor: 'accessing' stamp: 'lr 9/12/2007 22:54'!
label
	^ 'Tag Cloud'! !

!PRTagCloudWidget methodsFor: 'private' stamp: 'lr 2/23/2010 20:40'!
computeParameters
	| count |
	count := self tagsByCount size max: 1.
	mean := 0.0.
	deviation := 0.0.
	self tagsByCount do: [ :each | mean := mean + each value size ].
	mean := mean / count.
	self tagsByCount do: [ :each | deviation := deviation + (mean - each value size) abs ].
	deviation := deviation / count.
	deviation = 0.0 ifTrue: [ deviation := 1.0 ]! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'NickAger 1/30/2012 17:59'!
dataDescriptions
	^ dataDescriptions ifNil: [ dataDescriptions := self descriptionDataDescriptions default ]! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'NickAger 1/30/2012 17:56'!
dataDescriptions: anObject
	dataDescriptions := anObject! !

!PRTagCloudWidget methodsFor: 'accessing-description' stamp: 'NickAger 1/30/2012 17:30'!
descriptionDataDescriptions
	<magritteDescription>
	| optionsAndLabels |
	optionsAndLabels := Dictionary new.
	PRStructure
		withAllSubclassesDo: [ :class | 
			class description
				do: [ :each | 
					each isTagCloud
						ifTrue: [ optionsAndLabels at: each put: each label ] ] ].
	^ MAMultipleOptionDescription new
		optionsAndLabels: optionsAndLabels associations;
		reference: MADescription basicNew initialize magritteDescription;
		accessor: #dataDescriptions;
		default: optionsAndLabels keys;
		priority: 220;
		label: 'Data';
		beDistinct;
		yourself! !

!PRTagCloudWidget methodsFor: 'accessing-description' stamp: 'NickAger 1/30/2012 17:27'!
descriptionIgnoredTags
	<magritteDescription>
	^ MAMemoDescription new
		accessor: #ignoredTags;
		label: 'Ignored tags';
		priority: 220;
		yourself! !

!PRTagCloudWidget methodsFor: 'accessing-description' stamp: 'NickAger 1/30/2012 17:27'!
descriptionMaxItems
	<magritteDescription>
	^ MANumberDescription new
		accessor: #maxItems;
		label: 'Max Items';
		priority: 220;
		default: 50;
		beInteger;
		min: 1;
		yourself! !

!PRTagCloudWidget methodsFor: 'accessing-description' stamp: 'NickAger 1/30/2012 17:27'!
descriptionShowExponential
	<magritteDescription>
	^ MABooleanDescription new
		checkboxLabel: 'Exponential';
		accessor: #showExponential;
		default: false;
		priority: 235;
		yourself! !

!PRTagCloudWidget methodsFor: 'accessing-description' stamp: 'NickAger 1/30/2012 17:27'!
descriptionShowFrequencies
	<magritteDescription>
	^ MABooleanDescription new
		accessor: #showFrequencies;
		checkboxLabel: 'Frequencies';
		default: false;
		label: 'Show';
		priority: 230;
		yourself! !

!PRTagCloudWidget methodsFor: 'accessing-description' stamp: 'NickAger 1/30/2012 17:27'!
descriptionStructure
	<magritteDescription>
	^ PRStructureDescription new
		accessor: #startAt;
		label: 'Start At';
		priority: 200;
		yourself! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'lr 2/23/2010 20:40'!
deviation
	deviation isNil
		ifTrue: [ self computeParameters ].
	^ deviation! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'lr 9/12/2007 22:32'!
enumerator
	"Answer an enumerator to visit the necessary structures to collect the tags."
	
	^ (self context enumeratorFor: self structure) with all! !

!PRTagCloudWidget methodsFor: 'actions' stamp: 'lr 9/14/2007 17:56'!
focus: anAssocation
	focus := anAssocation! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'NickAger 1/30/2012 17:33'!
ignoredTags
	^ ignoredTags! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'NickAger 1/30/2012 17:33'!
ignoredTags: anObject
	ignoredTags := anObject! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'NickAger 1/30/2012 17:34'!
maxItems
	^ maxItems! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'NickAger 1/30/2012 17:34'!
maxItems: anObject
	maxItems := anObject! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'lr 2/23/2010 20:40'!
mean
	mean isNil
		ifTrue: [ self computeParameters ].
	^ mean! !

!PRTagCloudWidget methodsFor: 'rendering' stamp: 'lr 9/14/2007 19:01'!
renderCloudOn: html
	self tagsByName 
		do: [ :assoc | self renderTag: assoc on: html ]
		separatedBy: [ html text: ' ' ]! !

!PRTagCloudWidget methodsFor: 'rendering' stamp: 'lr 9/14/2007 17:57'!
renderContentOn: html
	focus isNil
		ifTrue: [ self renderCloudOn: html ]
		ifFalse: [ self renderFocusOn: html ]! !

!PRTagCloudWidget methodsFor: 'rendering' stamp: 'lr 9/17/2007 08:40'!
renderFocusOn: html
	| structures related |
	structures := focus value asSet
		asSortedCollection: [ :a :b | a title < b title ].
	html heading level: 1; with: [ 
		html anchor
			callback: [ focus := nil ];
			with: focus key ].
	html definitionList: [
		structures do: [ :each |
			html definitionTerm: [
				html anchor
					callback: [ 
						self context: (self context structure: each).
						focus := nil ];
					with: each title ].
			html definitionData: [
				related := self tagsByCount
					select: [ :assoc | assoc key ~= focus key and: [ assoc value includes: each ] ].
				((related last: (5 min: related size))
					asSortedCollection: [ :a :b | a key < b key ])
					do: [ :assoc | self renderTag: assoc on: html ]
					separatedBy: [ html text: ' ' ] ] ] ]! !

!PRTagCloudWidget methodsFor: 'rendering' stamp: 'NickAger 1/30/2012 17:53'!
renderTag: anAssociation on: html
	| diff percent |
	(self showExponential)
		ifTrue: [
			| min max |
			min := self tagsByCount first value size.
			max := self tagsByCount last value size.
			(diff := max - min) isZero
				ifTrue: [ diff := 1 ].
			percent := ((anAssociation value size - min) * 100.0 / diff) + 100 ]
		ifFalse: [
			diff := ((anAssociation value size - self mean) / self deviation) exp.
			percent := ((diff - 1) / (diff + 1) * (1.8 ln)) exp * 100.0 ].
		
	self renderTag: anAssociation on: html fontSize: percent! !

!PRTagCloudWidget methodsFor: 'rendering' stamp: 'NickAger 1/30/2012 17:53'!
renderTag: anAssociation on: html fontSize: fontSize
	html span class: 'tag'; with: [
		html anchor
			callback: [ self focus: anAssociation ];
			style: 'font-size: ' , fontSize truncated asString , '%';
			with: anAssociation key.
		(self showFrequencies) ifTrue: [
			html span
				class: 'freq';
				with: [ html space; text: '('; render: anAssociation value size; text: ')' ] ] ]! !

!PRTagCloudWidget methodsFor: 'actions' stamp: 'lr 2/23/2010 20:39'!
reset
	tags := tagsByName := tagsByCount := focus := mean := deviation := nil! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'NickAger 1/30/2012 17:35'!
showExponential
	^ showExponential! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'NickAger 1/30/2012 17:35'!
showExponential: anObject
	showExponential := anObject! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'NickAger 1/30/2012 17:36'!
showFrequencies
	^ showFrequencies! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'NickAger 1/30/2012 17:36'!
showFrequencies: anObject
	showFrequencies := anObject! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'NickAger 1/30/2012 17:54'!
startAt
	^ startAt! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'NickAger 1/30/2012 17:54'!
startAt: anObject
	startAt := anObject! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'NickAger 1/30/2012 17:56'!
structure
	"Answer the structure where the search for the tag cloud should start from."
	
	^ self startAt ifNil: [ self startAt: self context root. self startAt ]! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'NickAger 1/30/2012 18:00'!
tags
	"Answer a dictionary mapping tags to structures."
	
	tags isNil
		ifFalse: [ ^ tags ].
	tags := Dictionary new.
	self enumerator do: [ :struct |
		(self dataDescriptions) do: [ :description |
			(self tokenize: struct using: description) do: [ :tag |
				(tags at: tag ifAbsentPut: [ OrderedCollection new ])
					add: struct ] ] ].
	^ tags! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'NickAger 1/30/2012 18:00'!
tagsByCount
	"Answer a dictionary mapping tags to structures. The tags are sorted by count and cut to a certain threshold."
	
	tagsByCount isNil
		ifFalse: [ ^ tagsByCount ].
	tagsByCount := SortedCollection
		sortBlock: [ :a :b | a value size < b value size ].
	self tags associationsDo: [ :assoc | tagsByCount add: assoc ].
	(self maxItems) isNil
		ifFalse: [ tagsByCount := tagsByCount last: (tagsByCount size min: (self maxItems)) ].
	^ tagsByCount! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'lr 9/14/2007 18:05'!
tagsByName
	"Answer the tags alphabetically sorted by name."
	
	tagsByName isNil
		ifFalse: [ ^ tagsByName ].
	^ tagsByName := self tagsByCount 
		asSortedCollection: [ :a :b | a key < b key ]! !

!PRTagCloudWidget methodsFor: 'private' stamp: 'tg 11/17/2007 00:32'!
tokenize: anObject using: aDescription
	| string tokens ignoredTokens |
	(aDescription accessor canRead: anObject)
		ifFalse: [ ^ #() ].
	string := aDescription toString: (anObject readUsing: aDescription).
	string := string collect: [ :each | 
		each isLetter
			ifTrue: [ each asLowercase ]
			ifFalse: [ 
				each = $-
					ifTrue: [ each ]
					ifFalse: [ $  ] ] ].
	tokens := string findTokens: ' '.
	ignoredTokens := self ignoredTags findTokens: ' '.
	^ tokens reject: [ :each | each size = 1 or: [ (StopWords includes: each) or: [ignoredTokens includes: each] ] ]
! !
PRTagCloudWidget initialize!
